All Classes Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
HashIterator Class Reference

iterator class for QoreHashNode, to be only created on the stack More...

`#include <QoreHashNode.h>`

Inheritance diagram for HashIterator:
[legend]
Collaboration diagram for HashIterator:
[legend]

## Public Member Functions

DLLEXPORT | HashIterator (QoreHashNode *h)
| initializes the iterator with the passed hash
DLLEXPORT | HashIterator (QoreHashNode &h)
| initializes the iterator with the passed hash
DLLEXPORT bool | next ()
| moves to the next element, returns false when there are no more elements to iterate
DLLEXPORT bool | prev ()
| moves to the previous element, returns false when there are no more elements to iterate
DLLEXPORT const char * | getKey () const
| returns the current key
DLLEXPORT QoreString * | getKeyString () const
| returns a QoreString for the current key, the caller owns QoreString returned
DLLEXPORT AbstractQoreNode * | getValue () const
| returns the value of the current key
DLLEXPORT AbstractQoreNode * | takeValueAndDelete ()
| deletes the key from the hash and returns the value, caller owns the reference
DLLEXPORT void | deleteKey (ExceptionSink *xsink)
| deletes the key from the hash and dereferences the value
DLLEXPORT AbstractQoreNode ** | getValuePtr () const
| returns a pointer to a pointer to the current value so the value of the key may be manipulated externally
DLLEXPORT AbstractQoreNode * | getReferencedValue () const
| returns the value of the current key with an incremented reference count
DLLEXPORT bool | first () const
| returns true if on the first key of the hash
DLLEXPORT bool | last () const
| returns true if on the last key of the hash
DLLEXPORT bool | empty () const
| returns true if the hash is empty
DLLEXPORT bool | valid () const
| returns true if the iterator is currently pointing at a valid element

## Protected Member Functions

DLLLOCAL | HashIterator (const HashIterator &)
| this function is not implemented; it is here as a private function in order to prohibit it from being used
DLLLOCAL HashIterator & | operator= (const HashIterator &)
| this function is not implemented; it is here as a private function in order to prohibit it from being used
DLLLOCAL void * | operator new (size_t)
| this function is not implemented; it is here as a private function in order to prohibit it from being used

## Friends

class | HashAssignmentHelper

## Detailed Description

iterator class for QoreHashNode, to be only created on the stack

HashIterator hi(h);
while (hi.next()) {
QoreStringValueHelper str(hi.getValue());
printf("key: '%s', value: '%s'\n", hi.getKey(), str->getBuffer());
}

## Member Function Documentation

DLLEXPORT void HashIterator::deleteKey | ( | ExceptionSink * | xsink | ) |

deletes the key from the hash and dereferences the value

the pointer is moved to the previous element (or before the beginning) so that the next call to next() will put the pointer on the element after the one being deleted

DLLEXPORT AbstractQoreNode** HashIterator::getValuePtr | ( |  | ) | const

returns a pointer to a pointer to the current value so the value of the key may be manipulated externally

Deprecated:
  use HashAssignmentHelper instead; using this function could result in a memory leak

DLLEXPORT bool HashIterator::next | ( |  | ) |

moves to the next element, returns false when there are no more elements to iterate

also moves to the first element if the object has just been initialized after a complete iteration (assuming there is at least one element in the hash)

DLLEXPORT bool HashIterator::prev | ( |  | ) |

moves to the previous element, returns false when there are no more elements to iterate

also moves to the last element if the object has just been initialized after a complete iteration (assuming there is at least one element in the hash)

The documentation for this class was generated from the following file:

- include/qore/QoreHashNode.h (5431)